#!/usr/bin/perl -w

use strict;
use CGI qw|:standard :html3|;
use Digest::SHA1  qw(sha1_hex);
use utf8;
no utf8;

my $rootdir=$1 if $ENV{"SCRIPT_FILENAME"} =~ m|^(.*)/cgi-bin/|;
my $validdests=join "|",qw|agriva cashare circulaire credita creditreformsvc
 creditreform cscm deltavista dun infokey infosuisse inkassoarena inkassostelle
 intrum orc orell rci swissreport wys zek|;
my $q=new CGI;
my $sha1 = Digest::SHA1->new;

sub filter {
    my $varname=shift;
    my $string="";
    if ($varname =~ /nopo/) {
	$string=param($varname) if defined param($varname);
	return $1 if $string =~ /^(\d{4})$/;
    } elsif ($varname =~ /dest/) {
	return join(" ",grep {/^($validdests)$/} param($varname))
	    if defined param($varname);
    } else {
	$string=param($varname) if defined param($varname);
	utf8::decode($string) unless utf8::is_utf8($string);
	$string=~ s/\s*$//g;
	$string=~ s/^\s*//g;
	$string=~ s/\s+\s*/ /g;
	return "" unless $string =~ /^([\pL\pN .,+&-]+)$/;
	$string=~s/&/\\&/g;
	return $string;
    }

}

my $name=filter("name");
my $adrs=filter("adrs");
my $nopo=filter("nopo");
my $lieu=filter("lieu");
my $dest=filter("dest");
my $reco=0;
$reco=1 if defined param("reco") && param("reco") =~ /oui/;

if ( ! $name || ! $adrs || ! $nopo || ! $lieu || ! $dest ) {
    print header('text/html','403 Forbidden').
	start_html({-title=>'403 Forbidden'}),
	h1('Forbidden'),
	p("You don't have permission to acces ".
	  $ENV{'SCRIPT_NAME'}." on this server"),
	table(TR([th({-colspan=>"2"},"Maybe there is an error in form"),
		  td("Nom").td($name),td("Adresse").td($adrs),
		  td("Nro Postal").td($nopo),td("lieu").td($lieu),
		  td("Destinataires").td($dest)])),
	hr,address($ENV{'SERVER_SOFTWARE'}." Server at ".$ENV{'SERVER_NAME'}.
		   " Port ".$ENV{'SERVER_PORT'} );
    exit 0;
};
my $handler=sha1_hex(join("\n",($name,$adrs,$nopo,$lieu,$dest,$reco)));

if ( -f $rootdir."/var/".$handler.".pdf" ) {
    print header(-type=>'application/pdf',-attachment=>$handler.'.pdf');
    system "cat", $rootdir."/var/".$handler.".pdf";
    exit 0;
};

sleep 1 while (! rename $rootdir."/var/formLtrProtPers.lock",$rootdir."/var/formLtrProtPers.".$$);
unless (-f $rootdir."/var/".$handler.".pdf" ) {
    open my $fhandle,">".$rootdir."/var/from.tex";
    printf $fhandle "\\From{%s}%%\n\\Rue{%s}%%\n\\NoPost{%s}%%\n\\Lieu{%s}%%\n",
        $name,$adrs,$nopo,$lieu;
    close $fhandle;
    if ($reco) {
	system $rootdir."/var/lettre-db.sh","-r",$handler,split(" ",$dest);
    } else {
	system $rootdir."/var/lettre-db.sh",$handler,split(" ",$dest);
    };
}
rename $rootdir."/var/formLtrProtPers.".$$,$rootdir."/var/formLtrProtPers.lock";

if ( -f $rootdir."/var/".$handler.".pdf" ) {
    print header(-type=>'application/pdf',-attachment=>$handler.'.pdf');
    system "cat",$rootdir."/var/".$handler.".pdf";
    exit 0;
};

print header('text/plain');
print $rootdir." -> ".$handler."\n";
